--- a/daemons/daemon-util.in	2021-08-18 22:14:52.442908473 -0700
+++ b/daemons/daemon-util.in	2022-07-04 13:17:29.914663427 -0700
@@ -28,6 +28,7 @@
 # SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 set -e
+#set -x
 
 # Allow overriding for tests
 readonly LOCALSTATEDIR=${LOCALSTATEDIR:-${GANETI_ROOTDIR:-}/var}
@@ -330,11 +331,14 @@
   fi
 
   if type -p start-stop-daemon >/dev/null; then
-    start-stop-daemon --start --quiet --oknodo \
+    start-stop-daemon --start \
+      --wait 200 \
       --pidfile $pidfile \
-      --startas $daemonexec \
-      --chuid $usergroup \
+      --exec $daemonexec \
+      --user $usergroup \
       -- $args "$@"
+    rc=$?
+    return $?
   else
     # TODO: Find a way to start daemon with a group, until then the group must
     # be removed
@@ -360,7 +364,7 @@
   if use_systemctl; then
     systemctl stop "${name}.service"
   elif type -p start-stop-daemon >/dev/null; then
-    start-stop-daemon --stop --quiet --oknodo --retry 30 \
+    start-stop-daemon --stop --quiet --retry 30 \
       --pidfile $pidfile --name "$name"
   else
     _ignore_error killproc -p $pidfile $name
@@ -369,7 +373,7 @@
 
 # Starts a daemon if it's not yet running
 check_and_start() {
-  local name="$1"
+  local name="$1" ; shift
 
   if ! check $name; then
     if use_systemctl; then
@@ -377,7 +381,7 @@
       return 1
     fi
 
-    _start $name
+    _start $name "$@"
   fi
 }
 
@@ -469,7 +473,7 @@
 
   if type -p start-stop-daemon >/dev/null; then
     start-stop-daemon --stop --signal HUP --quiet \
-      --oknodo --pidfile $pidfile --name "$name"
+      --pidfile $pidfile --name "$name"
   else
     _ignore_error killproc \
       -p $pidfile \
